 package com.inet.ailink.receiver.controller;

 import com.inet.ailink.receiver.common.enums.StatusCode;
 import com.inet.ailink.receiver.common.vo.Response;
 import com.inet.ailink.receiver.service.impl.BloodPressureServiceImpl;
 import com.inet.ailink.receiver.service.impl.BodyFatServiceImpl;
 import org.springframework.beans.factory.annotation.Autowired;
 import org.springframework.web.bind.annotation.*;

 import javax.servlet.http.HttpServletRequest;
 import javax.servlet.http.HttpServletResponse;
 import java.io.IOException;

 @RestController
@RequestMapping(value="deData",produces={"application/json;charset=UTF-8"})
public class DeDataBaseController extends BaseController {

	@Autowired
	private BodyFatServiceImpl bodyFatServiceImpl;

	@Autowired
	private BloodPressureServiceImpl bloodPressureServiceImpl;

	/**
	 * 4G/WIFI+BLE设备测量结果数据
	 * @param params
	 * @param request
	 * @param response
	 * @throws IOException
	 */
	@RequestMapping(value="base_{cid}_{vid}_{pid}")
	@ResponseBody
	public void saveDataBase(@RequestBody String params,@PathVariable Integer cid,@PathVariable Integer vid,@PathVariable Integer pid,HttpServletRequest request,HttpServletResponse response) throws IOException {
		checkParams(response, params,cid,vid,pid);
		byte[] paramsByte = decryptParams(response,params);
		if(paramsByte.length >1){
			//WIFI_BLE体脂秤 cid = 17 ,WIFI体脂秤 cid = 25 ，4G体脂秤 cid = 57
			if(cid == 17 || cid == 25 || cid == 57){
				writeOutResponse(response, bodyFatServiceImpl.saveWeighDataByAdc(paramsByte, request));
			}
			//4G血压仪 cid = 48，WIFI+BLE血压仪 cid = 56
			else if(cid == 48 || cid == 56){
				writeOutResponse(response, bloodPressureServiceImpl.saveOrUpdateBloodPressure(paramsByte, request));
			}else{
				Response<Object> result = new Response<Object>();
				result.setStatus(StatusCode.DEVICE_UN_SUPPORT.getCode());
				writeOutResponse(response, result);
			}
		}else{
			writeOutResponse(response,paramsByte);
		}
	}
	
	
}